package de.unisaar.jfap.ex2;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

class EqualsAndHashCodeTest {

  @Test
  void test() {

    Movie movie1 = new Movie("Star Wars: Episode IV - A New Hope", 1977);
    Actor actor1 = new Actor("Mark", "Hamill");
    movie1.addActor(actor1);

    // equals check relies on field "id" only
    Movie movie2 = new Movie("Only ID Matters", 1988);
    movie1.setId(movie2.getId());
    Actor actor2 = new Actor("Only ID", "Matters");
    actor2.setId(actor1.getId());
    movie2.addActor(actor2);

    assertThat(movie1).isEqualTo(movie2);
    assertThat(actor1).isEqualTo(actor2);
    assertThat(movie1.hashCode()).isEqualTo(movie2.hashCode());
    assertThat(actor1.hashCode()).isEqualTo(actor2.hashCode());
  }
}
